with Model_Viewer.Counter;
use  Model_Viewer.Counter;
with Model_Viewer.Counter_Line_View;
use  Model_Viewer.Counter_Line_View;
with Model_Viewer.Counter_Box_View;
use  Model_Viewer.Counter_Box_View;
use  Model_Viewer;

procedure Demo_Model_Viewer is

   Model_One : Model_Ptr := new Counter_Type;
   View_One  : Counter_Line_View_Ptr;
   View_Two  : Counter_Box_View_Ptr;

begin
   Create (Counter_Line => View_One,
           What_I_Watch => Model_One, 
           For_Line     => '.',
           File_Name    => "counter_line.txt");
   Create (Counter_Box  => View_Two,
           What_I_Watch => Model_One, 
           For_Box      => '*',
           File_Name    => "counter_box.txt");

   for I in 0..9 loop
      if I rem 2 = 0 or I rem 3 = 0 then
         Increment (Counter => Counter_Type(Model_One.all));
      elsif I rem 7 = 0 then
         Reset (Counter => Counter_Type(Model_One.all));
      else
         Decrement (Counter => Counter_Type(Model_One.all));
      end if;
   end loop;

end Demo_Model_Viewer;
